function varargout = GLMGui(varargin)
% GLMGUI MATLAB code for GLMGui.fig
%      GLMGUI, by itself, creates a new GLMGUI or raises the existing
%      singleton*.
%
%      H = GLMGUI returns the handle to a new GLMGUI or the handle to
%      the existing singleton*.
%
%      GLMGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GLMGUI.M with the given input arguments.
%
%      GLMGUI('Property','Value',...) creates a new GLMGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GLMGui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GLMGui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GLMGui

% Last Modified by GUIDE v2.5 19-Mar-2017 09:40:34

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GLMGui_OpeningFcn, ...
                   'gui_OutputFcn',  @GLMGui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% *** this program was adapted from code and data created by Idan Blank 
% for a module on applying the General Linear Model to the analysis of 
% fMRI data for the MITx online course, Workshop on Quantitative Biology

% --- Executes just before GLMGui is made visible.
function GLMGui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GLMGui (see VARARGIN)

handles.signum = 0;     % index of signal to use for GLM analysis
handles.signal = [];    % signal for GLM analysis
handles.b1 = 60;        % beta weight for constant predictor
handles.b2 = 0;         % beta weight for sentence predictor
handles.b3 = 0;         % beta weight for nonwords predictor
handles.SSE = 0;        % sum of squared errors
handles.newFlag = 0;    % switch from exploration to fitting signals

% create the three predictors
load('designMatrix.mat','-ascii')
designMatrix = reshape(designMatrix,[189, 11]);
handles.x1 = designMatrix(:,11);    % constant predictor
handles.x2 = designMatrix(:,1);     % sentence predictor
handles.x3 = designMatrix(:,3);     % nonwords predictor

% load four signals to be predicted with GLM
load('signals4.mat')
handles.allSignals = allSignals;

% set hold on for all display areas
axes(handles.CGraph)
hold on
axes(handles.SGraph)
hold on
axes(handles.NGraph)
hold on
axes(handles.updateGraph)
hold on
xlabel('Time', 'FontSize', 16)
ylabel('Signal intensity', 'FontSize', 16)

% update display for initial beta weights
handles = updateBetas(handles);

% Choose default command line output for GLMGui
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GLMGui wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = GLMGui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on slider movement.
function CSlider_Callback(hObject, eventdata, handles)
% hObject    handle to CSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% user moved slider for B1, so update display
handles.b1 = get(hObject,'Value');
handles = updateBetas(handles);
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function CSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function SSlider_Callback(hObject, eventdata, handles)
% hObject    handle to SSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% user moved slider for B2, so update display
handles.b2 = get(hObject,'Value');
handles = updateBetas(handles);
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function SSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function NSlider_Callback(hObject, eventdata, handles)
% hObject    handle to NSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% user moved slider for B3, so update display
handles.b3 = get(hObject,'Value');
handles = updateBetas(handles);
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function NSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function B1Text_Callback(hObject, eventdata, handles)
% hObject    handle to B1Text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% user modified B1, so update display
% force B1 to stay within range from 60 to 110
handles.b1 = min(str2double(get(hObject,'String')), 110);
handles.b1 = max(handles.b1, 60);
handles = updateBetas(handles);
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function B1Text_CreateFcn(hObject, eventdata, handles)
% hObject    handle to B1Text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function B2Text_Callback(hObject, eventdata, handles)
% hObject    handle to B2Text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% user modified B2, so update display
% force B2 to stay within range from -2 to 6
handles.b2 = min(str2double(get(hObject,'String')), 6);
handles.b2 = max(handles.b2, -2);
handles = updateBetas(handles);
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function B2Text_CreateFcn(hObject, eventdata, handles)
% hObject    handle to B2Text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function B3Text_Callback(hObject, eventdata, handles)
% hObject    handle to B3Text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% user modified B3, so update display
% force B3 to stay within range from -2 to 6
handles.b3 = min(str2double(get(hObject,'String')),6);
handles.b3 = max(handles.b3,-2);
handles = updateBetas(handles);
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function B3Text_CreateFcn(hObject, eventdata, handles)
% hObject    handle to B3Text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in newSigBtn.
function newSigBtn_Callback(hObject, eventdata, handles)
% hObject    handle to newSigBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% set up new signal for prediction using GLM
handles.newFlag = 1;
handles.signum = 1 + handles.signum;
if (handles.signum == 5)
    handles.signum = 1;
end
handles.signal = handles.allSignals{handles.signum};
set(handles.updateLabel, 'String', ...
    ['Updated Signal Approximation for Signal #' num2str(handles.signum)])
handles.b1 = 60;
handles.b2 = 0;
handles.b3 = 0;
handles = updateBetas(handles);
% Update handles structure
guidata(hObject, handles);

function handles = updateBetas(handles)
% resets display after any change in one or more beta weights
set(handles.B1Text, 'String', num2str((round(100*handles.b1))/100));
set(handles.CSlider, 'Value', handles.b1);
set(handles.B2Text, 'String', num2str((round(100*handles.b2))/100));
set(handles.SSlider, 'Value', handles.b2);
set(handles.B3Text, 'String', num2str((round(100*handles.b3))/100));
set(handles.NSlider, 'Value', handles.b3);
% display constant predictor
axes(handles.CGraph);
cla
plot(handles.x1*handles.b1, 'r');
plot(handles.x1, 'b');
axis([0 200 0 115])
% display sentence predictor
axes(handles.SGraph);
cla
plot(handles.x2*handles.b2, 'r');
plot(handles.x2, 'b');
axis([0 200 -2.4 7])
% display nonwords predictor
axes(handles.NGraph)
cla
plot(handles.x3*handles.b3, 'r');
plot(handles.x3, 'b')
axis([0 200 -2.4 7])
glm = handles.b1*handles.x1 + handles.b2*handles.x2 + handles.b3*handles.x3;
axes(handles.updateGraph);
cla
plot(glm, '-', 'color', [1 0 1], 'linewidth', 1);
if handles.newFlag == 0     % still just exploring
    axis([0 200 handles.b1-5 handles.b1+10])
    set(handles.SSEtext, 'String', '');
else                        % signal exists for comparison with prediction
    plot(handles.signal, '-k', 'linewidth', 1);
    minv = min([min(glm) min(handles.signal)]);
    maxv = max([max(glm) max(handles.signal)]);
    axis([0 200 minv-1 maxv+1])
    % compute the error between the signal and its approximation
    error = handles.signal' - glm;
    handles.SSE = sum(error.^2);      % integrate error into SSE
    handles.SSE = (round(100*handles.SSE))/100;
    set(handles.SSEtext, 'String', num2str(handles.SSE));
end

% --- Executes on button press in bestBtn.
function bestBtn_Callback(hObject, eventdata, handles)
% hObject    handle to bestBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% determines beta weights corresponding to best fit of predicted signal
% (linear combination of predictors) to actual time series signal
X = [handles.x1 handles.x2 handles.x3];
betas = regress(handles.signal', X);
handles.b1 = betas(1);
handles.b2 = betas(2);
handles.b3 = betas(3);
handles = updateBetas(handles);
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in errorBtn.
function SSELabel_Callback(hObject, eventdata, handles)
% hObject    handle to errorBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes on button press in sentenceButton.
function sentenceButton_Callback(hObject, eventdata, handles)
% hObject    handle to sentenceButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% show figures for Sentences > Nonwords contrast
figure(1)
imshow('sentence1.png');
figure(2)
imshow('sentence2.png');

% --- Executes on button press in nonwordsButton.
function nonwordsButton_Callback(hObject, eventdata, handles)
% hObject    handle to nonwordsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% show figures for Nonwords > Sentences contrast
figure(3)
imshow('nonsent1.png');
figure(4)
imshow('nonsent2.png');

% --- Executes on button press in quitBtn.
function quitBtn_Callback(hObject, eventdata, handles)
% hObject    handle to quitBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close all
delete(handles.figure1);
