function varargout = mriGUI(varargin)
% MRIGUI MATLAB code for mriGUI.fig
%      MRIGUI, by itself, creates a new MRIGUI or raises the existing
%      singleton*.
%
%      H = MRIGUI returns the handle to a new MRIGUI or the handle to
%      the existing singleton*.
%
%      MRIGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MRIGUI.M with the given input arguments.
%
%      MRIGUI('Property','Value',...) creates a new MRIGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before mriGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to mriGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help mriGUI

% Last Modified by GUIDE v2.5 10-Nov-2016 13:19:41

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @mriGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @mriGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% *** this program was adapted from code and data created by Idan Blank 
% for a module on applying the General Linear Model to the analysis of 
% fMRI data for the MITx online course, Workshop on Quantitative Biology

% --- Executes just before mriGUI is made visible.
function mriGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to mriGUI (see VARARGIN)

% load anatomical and functional MRI data
load('anat.mat', '-ascii')
handles.anat = reshape(anat, [189,157,136]);
load('funcIm.mat','-ascii')
handles.funcIm = reshape(funcIm,[95,79,69]);
% coordinates for three sample voxels
handles.voxels = [133 125 69; 89 105 47; 50 45 100];
% display anatomical slices for first voxel
handles.voxNum = 1;
x = handles.voxels(handles.voxNum, 1);
y = handles.voxels(handles.voxNum, 2);
z = handles.voxels(handles.voxNum, 3);
fMRI1(handles,x,y,z)
    
% Choose default command line output for mriGUI
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes mriGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = mriGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on selection change in mriMenu.
function mriMenu_Callback(hObject, eventdata, handles)
% hObject    handle to mriMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns mriMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from mriMenu

if (get(hObject, 'Value') == 1)     % user selected MRI option
    x = handles.voxels(handles.voxNum, 1);
    y = handles.voxels(handles.voxNum, 2);
    z = handles.voxels(handles.voxNum, 3);
    fMRI1(handles,x,y,z)
    set(handles.voxelButton, 'String', 'show new voxel')
    set(handles.voxelText, 'Visible', 'on')
    set(handles.voxelText, 'String', ['Voxel #' num2str(handles.voxNum)])
else                                % user selected fMRI option
    fMRI2(handles)
    set(handles.voxelText, 'Visible', 'off')
    set(handles.voxelButton, 'String', 'show time series')
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function mriMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mriMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in voxelButton.
function voxelButton_Callback(hObject, eventdata, handles)
% hObject    handle to voxelButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if (get(handles.mriMenu, 'Value') == 1)   % MRI selected - show next voxel
    handles.voxNum = 1 + handles.voxNum;
    if (handles.voxNum == 4)
        handles.voxNum = 1;
    end
    set(handles.voxelText, 'String', ['Voxel #' num2str(handles.voxNum)])
    x = handles.voxels(handles.voxNum, 1);
    y = handles.voxels(handles.voxNum, 2);
    z = handles.voxels(handles.voxNum, 3);
    fMRI1(handles,x,y,z)
else                            % fMRI selected - show time series
    figure
    imshow('voxels.png')
end
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in closeButton.
function closeButton_Callback(hObject, eventdata, handles)
% hObject    handle to closeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close all
delete(handles.figure1)

